Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.opensymphony.xwork2.interceptor
Class ParametersInterceptor

    java.lang.Object
      com.opensymphony.xwork2.interceptor.AbstractInterceptor
          com.opensymphony.xwork2.interceptor.ParametersInterceptor

All Implemented Interfaces:
  Interceptor, Serializable

    public class ParametersInterceptor

extends AbstractInterceptor

This interceptor sets all parameters on the value stack.

This interceptor gets all parameters from `ActionContext.getParameters()` and sets them on the value stack by calling `ValueStack.setValue(String, Object)`, typically resulting in the values submitted in a form request being applied to an action in the value stack. Note that the parameter map must contain a String key and often containers a String[] for the value.

The interceptor takes one parameter named 'ordered'. When set to true action properties are guaranteed to be set top-down which means that top action's properties are set first. Then it's subcomponents properties are set. The reason for this order is to enable a 'factory' pattern. For example, let's assume that one has an action that contains a property named 'modelClass' that allows to choose what is the underlying implementation of model. By assuring that modelClass property is set before any model properties are set, it's possible to choose model implementation during action.setModelClass() call. Similiarily it's possible to use action.setPrimaryKey() property set call to actually load the model class from persistent storage. Without any assumption on parameter order you have to use patterns like 'Preparable'.

Because parameter names are effectively OGNL statements, it is important that security be taken in to account. This interceptor will not apply any values in the parameters map if the expression contains an assignment (=), multiple expressions (,), or references any objects in the context (#). This is all done in the `acceptableName(String)` method. In addition to this method, if the action being invoked implements the `ParameterNameAware` interface, the action will be consulted to determine if the parameter should be set.

In addition to these restrictions, a flag (`XWorkMethodAccessor.DENY_METHOD_EXECUTION`) is set such that no methods are allowed to be invoked. That means that any expression such as person.doSomething() or person.getName() will be explicitely forbidden. This is needed to make sure that your application is not exposed to attacks by malicious users.

While this interceptor is being invoked, a flag (`InstantiatingNullHandler.CREATE_NULL_OBJECTS`) is turned on to ensure that any null reference is automatically created - if possible. See the type conversion documentation and the `InstantiatingNullHandler` javadocs for more information.

Finally, a third flag (`XWorkConverter.REPORT_CONVERSION_ERRORS`) is set that indicates any errors when converting the the values to their final data type (String[] -> int) an unrecoverable error occured. With this flag set, the type conversion errors will be reported in the action context. See the type conversion documentation and the `XWorkConverter` javadocs for more information.

If you are looking for detailed logging information about your parameters, turn on DEBUG level logging for this interceptor. A detailed log of all the parameter keys and values will be reported.

Interceptor parameters:

- ordered - set to true if you want the top-down property setter behaviour

Extending the interceptor:

The best way to add behavior to this interceptor is to utilize the `ParameterNameAware` interface in your actions. However, if you wish to apply a global rule that isn't implemented in your action, then you could extend this interceptor and override the `acceptableName(String)` method.

Example code:

     <action name="someAction" class="com.examples.SomeAction">
         <interceptor-ref name="params"/>
         <result name="success">good_result.ftl</result>
     </action>

Author:
  Patrick Lightbody
See Also:
  Serialized Form

Field Summary
`(package private) static boolean` | `devMode`
`(package private) Set<Pattern>` | `excludeParams`
`private static Log` | `LOG`
`(package private) boolean` | `ordered`
`(package private) static Comparator` | `rbCollator` Compares based on number of '.' characters (fewer is higher)

Constructor Summary
`ParametersInterceptor()`

Method Summary
`protected boolean` | `acceptableName(String name)`
`private Collection` | `asCollection(String commaDelim)` Return a collection from the comma delimited String.
`protected Set` | `getExcludeParamsSet()` Gets a set of regular expressions of parameters to remove from the parameter map
`protected Comparator` | `getOrderedComparator()` Gets an instance of the comparator to use for the ordered sorting.
`private String` | `getParameterLogMap(Map parameters)`
`String` | `intercept(ActionInvocation invocation)` Override to handle interception
`protected boolean` | `isExcluded(String paramName)`
`boolean` | `isOrdered()` Whether to order the parameters or not
`static void` | `setDevMode(String mode)`
`void` | `setExcludeParams(String commaDelim)` Sets a comma-delimited list of regular expressions to match parameters that should be removed from the parameter map.
`void` | `setOrdered(boolean ordered)` Set whether to order the parameters by object depth or not
`protected void` | `setParameters(Object action, ValueStack stack, Map parameters)`

Methods inherited from class com.opensymphony.xwork2.interceptor.AbstractInterceptor
`destroy, init`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### LOG

    private static final Log LOG

### ordered

    boolean ordered

### excludeParams

    Set<Pattern> excludeParams

### devMode

    static boolean devMode

### rbCollator

    static final Comparator rbCollator

  Compares based on number of '.' characters (fewer is higher)

Constructor Detail

### ParametersInterceptor

    public ParametersInterceptor()

Method Detail

### setDevMode

    public static void setDevMode(String mode)

### intercept

    public String intercept(ActionInvocation invocation)
                     throws Exception

  Description copied from class: `AbstractInterceptor`
  Override to handle interception

  Specified by:
    `intercept` in interface `Interceptor`
  Specified by:
    `intercept` in class `AbstractInterceptor`
  Returns:
    the return code, either returned from `ActionInvocation.invoke()`, or from the interceptor itself.
  Throws:
    `Exception` - any system-level error, as defined in `Action.execute()`.

### setParameters

    protected void setParameters(Object action,
                                 ValueStack stack,
                                 Map parameters)

### getOrderedComparator

    protected Comparator getOrderedComparator()

  Gets an instance of the comparator to use for the ordered sorting. Override this method to customize the ordering of the parameters as they are set to the action.

  Returns:
    A comparator to sort the parameters

### getParameterLogMap

    private String getParameterLogMap(Map parameters)

### acceptableName

    protected boolean acceptableName(String name)

### isExcluded

    protected boolean isExcluded(String paramName)

### isOrdered

    public boolean isOrdered()

  Whether to order the parameters or not

  Returns:
    True to order

### setOrdered

    public void setOrdered(boolean ordered)

  Set whether to order the parameters by object depth or not

  Parameters:
    `ordered` - True to order them

### getExcludeParamsSet

    protected Set getExcludeParamsSet()

  Gets a set of regular expressions of parameters to remove from the parameter map

  Returns:
    A set of compiled regular expression patterns

### setExcludeParams

    public void setExcludeParams(String commaDelim)

  Sets a comma-delimited list of regular expressions to match parameters that should be removed from the parameter map.

  Parameters:
    `commaDelim` - A comma-delimited list of regular expressions

### asCollection

    private Collection asCollection(String commaDelim)

  Return a collection from the comma delimited String.

  Parameters:
    `commaDelim` -
  Returns:
    A collection from the comma delimited String.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Apache Software Foundation. All Rights Reserved.